<?php
// phpinfo();

include "hamlibweb_lib.php";
?>

<HTML>
<HEAD><TITLE>Hamlib WebRig <?php echo $dest ?> <?php echo $port ?></TITLE></HEAD>
<BODY>

<?php
HamHeader("adif");

class AdifObj {
	private $_freq ;
	private $_mode ;
	private $_ok ;

	private $_name;
	private $_notes;

	public function __construct( $s )
	{
		if(
			( preg_match("/<FREQ:[0-9]*>([^<]*)/", $s, $mtch_freq)) &&
			( preg_match("/<MODE:[0-9]*>([^<]*)/", $s, $mtch_mode)) 
		)
		{
			$this->_freq = $mtch_freq[1];
			$this->_mode = $mtch_mode[1];
			$this->_ok = 1;

			if ( preg_match("/<NAME:[0-9]*>([^<]*)/", $s, $mtch_name) )
			{
				$this->_name = $mtch_name[1];
			}

			if ( preg_match("/<NOTES:[0-9]*>([^<]*)/", $s, $mtch_notes) )
			{
				$this->_notes = $mtch_notes[1];
			}
		}
		else
		{
			$this->_ok = 0;
		}
	}

	public function Freq() { return $this->_freq ; }
	public function Mode() { return $this->_mode ; }
	public function Ok() { return $this->_ok ; }
	public function Notes() { return $this->_notes ; }
	public function Name() { return $this->_name ; }
}

class AdifFile {
	private $_ok ;
	private $_fil ;
	private $_records ;
	public function __construct( $f )
	{
		$this->_fil = $f ;
	}

	public function Load()
	{
		$hnd = fopen($this->_fil,"r");
		if( $hnd )
		{
			while (!feof($hnd))
			{
				$buf = fgets($hnd);
				$ad = new AdifObj( $buf );
				if( $ad->Ok() )
				{
					$this->_records[] = $ad ;
				}
			}
			return 1 ;
		}
		else
		{
			return 0 ;
		}
	}

	public function Records() { return $this->_records ; }
}

// A voir
// http://qrg.dk1ny.ath.cx/?
?>

<table border=1>
<tr>

<?php
if ($dh = opendir(AdifDir()))
{
	while (($file = readdir($dh)) !== false)
	{
		$full_file = AdifDir() . $file ;
		if(preg_match("/(.*)\.adif\$/", $file, $matches))
		{
			$key = $matches[1];
?>
<td bgcolor="#ddffdd">
<a href="adif.php?key=<?php echo $key ?>" bgcolor=black><?php echo $key ?></a>
</td>
<?php
		}
	}
	closedir($dh);
}
?>
</tr>
</table>
<br>

<table border=1>
<?php
// File: london.adif
// <ADIF_VER:5>2.1.9
// <PROGRAMID:8>RigSched
// <PROGRAMVERSION:4>1.00
// <EOH>
// <QSO_DATE:8>20090501<BAND:3>30m<FREQ:6>198000<MODE:2>AM<NOTES:11>BBC Radio 4<TIME_ON:4>0000<TIME_OFF:4>2359<TX_PWR:1>5<EOR>
$key = $_GET["key"] ;
$curr_freq = $_GET["frequency"] ;

if( $key )
{
	$full_file = AdifDir() . $key . ".adif" ;
	$ad_fi = new AdifFile( $full_file );

	if( $ad_fi->Load() )
	{
		$counter = 1 ;
		foreach( $ad_fi->Records() as $ad )
		{
			$id = "c$counter" ;
			$counter = $counter + 1 ;
			$name = $ad->Name();
			$notes = $ad->Notes();
			$freq = $ad->Freq();
			$mode = $ad->Mode();
			if( ($name=="") && ($notes=="") )
			{
				$name=$freq;
			}

			if( $curr_freq == $freq )
			{
				$bg_col="#FFcccc" ;
			}
			else
			{
				$bg_col="#DDFFFF" ;
			}


			$url = "adif.php" . "?frequency=".$freq."&mode=".$mode."&key=".$key ;
?>
	<tr bgcolor=<?php echo $bg_col ?> >
<td><a href="<?php echo "$url#$id" ?>" id="<?php echo$id ?>" ><?php echo $name ?></a><a name="$id"></td>
<td><a href="<?php echo $url ?>"><?php echo $notes ?></a></td>
<td align="right"><?php echo $freq ; ?></td>
<td><?php echo $mode ; ?></td>
</tr>
<?php
		}
	}
	else
	{
		echo "Cannot open:" . $full_file . " " . strerror($errno) ;
	}
}
?>
</table>

<?php
	socket_close($socket);
?>
</BODY></HTML>

