<?php
/// You must start the hamlib server: rigctld.
// phpinfo();
//
// TODO: Add style sheet support.
// TODO: Host and port should be parameters.
// TODO: Adds support for reading frequency lists such as fmlist
	if( $hamlib_host == "" )
	{
		$hamlib_host = $_COOKIE["hamlib_host"];
		if( $hamlib_host == "" )
		{
			$hamlib_host="127.0.0.1";
		}
	}

	if( $hamlib_port == "" )
	{
		$hamlib_port = $_COOKIE["hamlib_port"];
		if( $hamlib_port == "" )
		{
			$hamlib_port="4532";
		}
	}



	/// These are the Hamlib errors.
	define("ERR_NOERROR", 0 );
	define("ERR_INV_PRM", 1 );
	define("ERR_INV_CFG", 2 );
	define("ERR_MEM_SHT", 3 );
	define("ERR_FEATIMP", 4 );
	define("ERR_TIMEOUT", 5 );
	define("ERR_IOERROR", 6 );
	define("ERR_INT_ERR", 7 );
	define("ERR_PROTERR", 8 );
	define("ERR_CMD_REJ", 9 );
	define("ERR_TRUNCAT",10 );
	define("ERR_FEATNAV",11 );
	define("ERR_TGT_VFO",12 );
	define("ERR_BUS_ERR",13 );
	define("ERR_BUS_COL",14 );
	define("ERR_NULLRIG",15 );
	define("ERR_INV_VFO",16 );
	define("ERR_ARG_OUT",17 );
	$rigErrors = array(
		ERR_NOERROR => "Command completed successfully",
		ERR_INV_PRM => "Invalid parameter",
		ERR_INV_CFG => "Invalid configuration",
		ERR_MEM_SHT => "Memory shortage",
		ERR_FEATIMP => "Feature not implemented",
		ERR_TIMEOUT => "Communication timed out",
		ERR_IOERROR => "IO error",
		ERR_INT_ERR => "Internal Hamlib error",
		ERR_PROTERR => "Protocol error",
		ERR_CMD_REJ => "Command rejected by the rig",
		ERR_TRUNCAT => "Command performed, but arg truncated, result not guaranteed",
		ERR_FEATNAV => "Feature not available",
		ERR_TGT_VFO => "Target VFO unaccessible",
		ERR_BUS_ERR => "Communication bus error",
		ERR_BUS_COL => "Communication bus collision",
		ERR_NULLRIG => "NULL RIG handle or invalid pointer parameter",
		ERR_INV_VFO => "Invalid VFO",
		ERR_ARG_OUT => "Argument out of domain of func" );

	function AdifDir()
	{
		return "../../RadioAmateurs/Adif/";
	}

	function CacheUrlFile($url,$tmpfi)
	{
		$curr_tm = time();
		$cache_file_exists = file_exists($tmpfi);
		if( ! $cache_file_exists || ( $curr_tm - filemtime($tmpfi) > 7 * 24 * 3600 ) )
		{
			$tmpstr = file_get_contents($url);
			if( strlen($tmpstr) <= 1 )
			{
				echo "no file on:" . $url . "<br>" ;
				if( $cache_file_exists )
				{
					echo "Using old cache file: $tmpfi<br>" ;
				}
				else
				{
					echo "No old cache file<br>" ;
					exit ;
				}
			}
			else
			{
				file_put_contents($tmpfi,$tmpstr);
			}
		}

		$arrfi = file($tmpfi);
		return $arrfi ;
	}

	function UrlMail($addr)
	{
		return "<a href=\"mailto:".$addr."\">".$addr."</a>";
	}



	function HamHeader($donot)
	{
?>
<table border=1>
</table>

<?php
	}

	if( ( $hamlib_host != "" ) && ( $hamlib_port != "" ) )
	{
		$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
		$r = socket_connect($socket, $hamlib_host, $hamlib_port);
		socket_getsockname($socket, $addr, $other_port);
	}

	class Item {
		private $var ;
		private $err ;
		public function __construct( $v, $e ) {
			$this->var = $v ;
			$this->err = $e ;
		}
		public function Value() {
			return $this->var ;
		}
		public function ErrCode() {
			return $this->err != 0 ;
		}
	}

	/// This sends a command to rigctld.
	function Send($msg)
	{
		global $socket ;
		if( $socket == "" )
		{
			return ;
		}
		usleep(10000);
		socket_write($socket, $msg . "\n" );
		$tmpFlush = socket_read($socket,1000);
		$tmpFlush = rtrim($tmpFlush);
		if( ( $msg[0] == "f" ) || ($msg[0] == "F" ) )
		{
			echo "Send [$msg] => [$tmpFlush]<br>" ;
		}

// Il faudrait peut etre boucler en lecture jusqu'au RPRT

		$nbSs = sscanf( $tmpFlush, "RPRT %d", $tmpErr );
		if( $nbSs == 1 ) {
			$ErrMsg = $rigErrors[$tmpErr];
			if( $ErrMsg == "" ) {
				$ErrMsg = "UnknownErr:" . $tmpErr ;
				return new Item($tmpFlush,-1) ;
			}
			return new Item($tmpFlush,$tmpErr) ;
		} else {
			return new Item($tmpFlush,0) ;
		}

	}

	$modesAll = array(
		"AM","FM","CW","USB","LSB","RTTY","WFM",
		);

	/// Gets the most important values from rigctld
	/// and sets the one which are passed as CGI variables.
	$fldigi_refresh = $_GET["fldigi_refresh"];
	if( $socket != "" )
	{
		if( $fldigi_refresh == "" )
		{
			$newFreq = $_GET["frequency"];
			if( $newFreq ) {
				Send("F " . $newFreq );
			}
		}
		$freq = Send("f");

		if( $fldigi_refresh == "" )
		{
			$newMode = $_GET["mode"];
			if( $newMode ) {
				$newPassband = $_GET["passband"] ;
				if( $newpassband == "" ) {
					$newPassband = "0";
				}
				Send("M " . $newMode . " " . $newPassband );
			}
		}
		$mode_passband = Send("m");
		if( $mode_passband )
		{
			sscanf( $mode_passband->Value(), "%s %s", $mode, $passband );
		}

		if( $fldigi_refresh == "" )
		{
			$newVFO = $_GET["vfo"];
			if( $newVFO ) {
				Send("V " . $newVFO );
			}
		}
		$vfo = Send("v");
	}
?>


